<?php


// ***** Conf ******************************************************************

$default_Debug              = true;
$default_DefaultGrp         = 'General';
$default_ExternAuth         = false;
$default_ListenPort         = 7000;
$default_MD5Crypt           = true;
$default_SecretWord         = '';
$default_SizeMsgsRoom       = 4096;
$default_UpdateInfo         = false;

$default_AlwaysStoreRooms   = true;
$default_AlwaysStoreUsers   = true;

$default_GuestCanEnter      = true;
$default_GuestCanSpeak      = true;
$default_GuestPrefix        = 'guest-';

$default_IntervalAdsMain    = 60;
$default_IntervalAdsRDef    = 60;
$default_IntervalAdsRMin    = 30;
$default_IntervalNoop       = 60;
$default_IntervalRCnt       = 00;
$default_IntervalType       = 01;

$default_LicenseCode        = '';
$default_LicenseHost        = '';

$default_LogFileSize        = 01;
$default_LogLevel           = 02;
$default_LogProfile         = false;
$default_LogServer          = false;
$default_LogToFile          = true;
$default_LogToScrn          = true;

$default_MaxActions         = 32;
$default_MaxClients         = 32;
$default_MaxRooms           = 32;
$default_MaxUsers           = 1024;
$default_MaxUsersAudio      = 32;
$default_MaxUsersVideo      = 32;
$default_MaxUserSrc         = 1024;

$default_MySQLHost          = 'localhost';
$default_MySQLSock          = '';
$default_MySQLUser          = '';
$default_MySQLPass          = '';
$default_MySQLDBase         = '';
$default_MySQLTable         = '';
$default_MySQLUserCol       = '';
$default_MySQLPassCol       = '';
$default_MySQLVeriCol       = '';
$default_MySQLKeepAlive     = false;

$default_PermAnyRoomAdEdt   = false;
$default_PermUsrRoomGener   = true;
$default_PermUsrRoomAudio   = true;
$default_PermUsrRoomVideo   = true;
$default_PermUsrRoomNoExp   = false;
$default_PermUsrRoomAdEdt   = false;

$default_ThreadsMin         = 02;
$default_ThreadsMax         = 05;
$default_ThreadSleep        = 100;

$default_UploadKeepTime     = 10;
$default_UploadSizeFile     = 128;
$default_UploadToOffline    = false;

$default_AdminName          = 'admin';
$default_Room               = 'Main room';

$default_URLRegister        = "http://{$_SERVER["SERVER_NAME"]}/";
$default_URLLostPass        = "http://{$_SERVER["SERVER_NAME"]}/";
$default_URLUpdate          = "http://{$_SERVER["SERVER_NAME"]}/";
$default_URLUserInfo        = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/userinfo.php?uname=";

$default_URLAdImages        = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/ads.php";
$default_URLRmImages        = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/ads.php";
$default_URLInfoGet         = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/info_get.php?uname=";
$default_URLInfoSet         = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/info_set.php";
$default_URLSendFile        = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/sendfile.php";
$default_URLUserAuth        = "http://{$_SERVER["SERVER_NAME"]}" . dirname(dirname($_SERVER["SCRIPT_NAME"])) . "/utils/validate.php";

$query_CntRooms     = 0x80;
$query_CntUsers     = 0x81;
$query_LstRooms     = 0x82;
$query_LstUsers     = 0x83;
$query_StatServ     = 0x84;
$query_StatUser     = 0x85;
$query_SysCmdLogin  = 0xb0;
$query_SysCmdLogoff = 0xb2;


// ***** Init ******************************************************************

error_reporting(E_ALL ^ E_NOTICE);
ini_set('display_errors', 1);
ini_set(    'log_errors', 0);

header('Pragma: no-cache');
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
header('Expires: Fri, 31 Dec 1999 23:59:59 GMT');

if (get_magic_quotes_gpc() && !function_exists('strip_slashes_deep'))
{
  function strip_slashes_deep($value)
  {
    return is_array($value) ? array_map('strip_slashes_deep', $value) : stripslashes($value);
  }
  $_GET    = strip_slashes_deep($_GET);
  $_POST   = strip_slashes_deep($_POST);
  $_COOKIE = strip_slashes_deep($_COOKIE);
}


// ***** Functions *************************************************************

// ***** ads_get_file *****

function ads_get_file()
{
  $ads = array();
  if ($handle = opendir("../utils/ads"))
  {
    while (false !== ($fname = readdir($handle)))
      if (preg_match("/^.*\\.(?i:swf|gif|jpg|jpeg)$/sDX", $fname, $matches))
        $ads[] = $matches[0];
    closedir($handle);
  }

  return $ads;
}

// ***** ads_get_conf *****

function ads_get_conf()
{
  if (              file_exists('../utils/ads/ads.cfg'))
       $cfg = file_get_contents('../utils/ads/ads.cfg');
  else $cfg = '';

  if (               trim($cfg))
       $cfg = unserialize($cfg);
  else $cfg = array();

  return $cfg;
}

// ***** ads_set_conf *****

function ads_set_conf($cfg)
{
       $cfg = file_put_contents('../utils/ads/ads.cfg', serialize($cfg));
}

// ***** cfg_get *****

function cfg_get()
{
  $rawcfg = file_get_contents("../files/serv.cfg");
  $rawcfg = explode("\r\n", $rawcfg);
  $parsed = array();
  foreach ($rawcfg as $i => $x) $rawcfg[$i] = explode("=", $x, 2);
  foreach ($rawcfg as $i => $x) if (isset($x[0]) && isset($x[1])) switch ($x[0])
  {
    case "__AdminName": $parsed[$x[0]][] = $x[1]; break;
    case "__Room"     : $parsed[$x[0]][] = $x[1]; break;
    default:            $parsed[$x[0]]   = $x[1];
  }
  return $parsed;
}

// ***** cfg_set *****

function cfg_set($parsed)
{
  $rawcfg = "";
  foreach ($parsed as $i => $x) switch ($i)
  {
    case "__AdminName": foreach ($x as $j => $y) if ($y) $rawcfg .= "$i=$y\r\n"; break;
    case "__Room"     : foreach ($x as $j => $y) if ($y) $rawcfg .= "$i=$y\r\n"; break;
    default:                                             $rawcfg .= "$i=$x\r\n";
  }
  return file_put_contents("../files/serv.cfg", $rawcfg) !== false;
}

// ***** date_parse  *****

if (!function_exists('date_parse'))
{
  function date_parse($date)
  {
    $date = explode('-', $date);
    return (count($date) < 3) ? false
                              : array('year'  => (integer)$date[0],
                                      'month' => (integer)$date[1],
                                      'day'   => (integer)$date[2]);
  }
}

// ***** file_put_contents *****

if (!function_exists('file_put_contents'))
{
  function file_put_contents($filename, $data)
  {
    $handle = @fopen($filename, "w");
    if (!$handle) return false;
    fwrite($handle, $data);
    fclose($handle);
    return true;
  }
}

?>